<script setup lang="ts">
    import { ItemLists } from '@/interventionServiceOffer/composables/equipement/useItemLists'
    import { interventionServiceOfferInjectionKey } from '@/interventionServiceOffer/constants'
    import { InterventionCycleEntity } from '@/interventionServiceOffer/entities/interventionCycleEntity/InterventionCycleEntity'
    import SMultiLinks from '@/shared/button/components/SMultiLinks.vue'
    import { formatageDatePourAffichage } from '@/shared/helpers/dates'
    import { isDefined, requiredInject } from '@/shared/helpers/types'
    import SExternalLinkOnDesktop from '@/shared/item/components/SExternalLinkOnDesktop.vue'
    import SAttributeAndValue from '@/shared/ui/components/SAttributeAndValue.vue'

    interface Props {
        entity: InterventionCycleEntity
        entityType: keyof ItemLists
        displayTitle?: boolean
        detailsLink?: boolean
    }

    const interventionServiceOffer = requiredInject(
        interventionServiceOfferInjectionKey
    )
    withDefaults(defineProps<Props>(), {
        displayTitle: true,
        detailsLink: false,
    })

    defineEmits<{
        selectItem: [itemType: keyof ItemLists, itemId: string]
    }>()
</script>

<template>
    <div>
        <s-attribute-and-value
            v-if="displayTitle"
            cypress-selector="title"
            attribut="titre"
        >
            {{ entity.title }}
        </s-attribute-and-value>
        <s-attribute-and-value cypress-selector="code" attribut="code">
            <a
                v-if="detailsLink"
                @click.prevent="$emit('selectItem', entityType, entity.id)"
            >
                {{ entity.code }}
            </a>
            <span v-else> {{ entity.code }} </span>&nbsp;
            <s-external-link-on-desktop
                v-if="
                    isDefined(
                        interventionServiceOffer?.data?.gmaoConfiguration
                            .environnement
                    )
                "
                :link="entity.gmaoObjectViewUrl"
                data-cy="gmaoObjectViewUrl"
            >
                {{
                    interventionServiceOffer.data.gmaoConfiguration
                        .environnement
                }}
            </s-external-link-on-desktop>
        </s-attribute-and-value>
        <s-attribute-and-value
            cypress-selector="date-and-creator"
            attribut="création"
        >
            {{
                entity.createdAt
                    ? 'Le ' +
                      formatageDatePourAffichage(entity.createdAt, 'jour')
                    : ''
            }}
            par
            <s-multi-links
                v-if="entity.createdBy"
                icon="mdi-phone-outline"
                :button-actions="entity.createdBy.getTelephonesButtonActions()"
                data-cy="phone-link"
            >
                {{ entity.createdBy.nomComplet }}
            </s-multi-links>
        </s-attribute-and-value>
        <s-attribute-and-value
            v-if="entity.relatedEquipement"
            cypress-selector="equipement"
            attribut="équipement"
        >
            {{ entity.relatedEquipement.label }} -
            <a
                class="cursor-pointer"
                @click.prevent="
                    $emit(
                        'selectItem',
                        'équipements',
                        entity.relatedEquipement.id
                    )
                "
            >
                {{ entity.relatedEquipement.code }} </a
            >&nbsp;
            <s-external-link-on-desktop
                v-if="
                    isDefined(
                        interventionServiceOffer?.data?.gmaoConfiguration
                            .environnement
                    )
                "
                :link="entity.relatedEquipement.gmaoObjectViewUrl"
            >
                {{
                    interventionServiceOffer.data.gmaoConfiguration
                        .environnement
                }}
            </s-external-link-on-desktop>
        </s-attribute-and-value>
        <s-attribute-and-value cypress-selector="address" attribut="adresse">
            <template v-if="entity.address" #default>
                {{ entity.address }}
            </template>
            <template v-else #empty-value> Aucune adresse </template>
        </s-attribute-and-value>
        <s-attribute-and-value
            cypress-selector="description"
            attribut="description"
        >
            <template v-if="entity.description" #default>
                {{ entity.description }}
            </template>
            <template v-else #empty-value> Aucune description </template>
        </s-attribute-and-value>
    </div>
</template>
